#include <QApplication>
#include <QWidget>
#include <unistd.h>
#include <QTimer>
#include <QLabel>
#include <QVariant>
#include <QVBoxLayout>

class MyWidget : public QWidget
{
    Q_OBJECT

public:
    MyWidget()
        : QWidget()
    {
        QVBoxLayout *v = new QVBoxLayout(this);
        v->addWidget(new QLabel("In 5 seconds resize will be called and PID will appear in the layout"));
        timer = new QTimer(this);
        connect(timer, SIGNAL(timeout()), this, SLOT(doResize()));
        timer->start(5000);
    }

public slots:

    void doResize()
    {
        resize(100,100);
        int pid = getpid();
        layout()->addWidget(new QLabel(QString("Application PID is: %1").arg(pid)));
        timer->stop();
        update();
    }

protected:
    QTimer *timer;

};

int main(int argc, char *argv[])
{

    QApplication a(argc, argv);
    MyWidget w;
    w.showFullScreen();
    return a.exec();
}

#include "main.moc"
